#
#
# set MD(connection) [ mi_open Prod ]
# mi_exec $MD(connection) "set schema GCMCheat;"
#
#
proc Min { a b } {
	if { $a > $b } {
		return $b
	} 
	return $a
}
#
proc Max { a b } {
	if { $a > $b } {
		return $a
	} 
	return $b
}
#
#
proc lines { x1 y1 x2 y2 U V P mU mV mP } {
#
# Set up the Min/Max values to ensure that the 
# subsequent trig works OK.
#
	set MinX [ Min $x1 $x2 ]
	set MaxX [ Max $x1 $x2 ]
	set MinY [ Min $y1 $y2 ]
	set MaxY [ Max $y1 $y2 ]
#
#  Distances along each edge
#
	set Dx [ expr ( $MaxX - $MinX ) ]
	set Dy [ expr ( $MaxY - $MinY ) ]
#
# Center
#
	set Cx [ expr $MinX + ( $Dx / 2 ) ]
	set Cy [ expr $MinY + ( $Dy / 2 ) ]
#
# Apex
#
	set Ax [ expr $Cx + ( ( $V * $Dx ) / ( $mV * 3 ) ) ]
	set Ay [ expr $Cy + ( ( $U * $Dy ) / ( $mU * 3 ) ) ]
#
# Base
#
	set Bx [ expr $Cx - ( ( $V * $Dx ) / ( $mV * 3 ) ) ]
	set By [ expr $Cy - ( ( $U * $Dy ) / ( $mU * 3 ) ) ]
#
# Now, the other two points.
#
	set Pp [ expr ( ($P / ( $mP * 5 ) ) * ( hypot($Dx,$Dy) / 3 ) ) ]
#
#  This is the length of the Base
#
	set Ht [ expr hypot(($Ax - $Bx),($Ay - $By)) ]
#
#  This is the length of the Hypot.
#
	set Hpt [ hypot(($Pp/2),$Ht) ]
#
#  This is the height of the triangle (Wind Velocity)
#
	set Bdx [ expr ((($Pp/2)*($Pp/2)) / $Ht ) ]
	set Bdy [ expr ((($Pp/2)*($Pp/2)) / $Ht ) ]

	set P1x [ expr $Bx - sqrt(($Pp*$Pp)/(($Dy/$Dx)+1)*(($Dy/$Dx) + 1)) ]
        set P2x [ expr $Bx + sqrt(($Pp*$Pp)/(($Dy/$Dx)+1)*(($Dy/$Dx) + 1)) ]

	set P1y [ expr $By + sqrt(($Pp*$Pp)/(($Dx/$Dy)+1)*(($Dx/$Dy) + 1)) ]
	set P2y [ expr $By - sqrt(($Pp*$Pp)/(($Dx/$Dy)+1)*(($Dx/$Dy) + 1)) ]
#
# Length 
#
#	puts " U is $U and mU is $mU "
	set dU [ expr ($U/$mU) ]
#	puts " V is $V and mV is $mV "
	set dV [ expr ($V/$mV) ]
#	puts " dU is $dU and dV is $dV "
	set L [ expr sqrt(((abs($U)/$mU )*(abs($U)/$mU)) + ((abs($V)/$mV)*(abs($V)/$mV))) ]
#
#  Test Print
#
#	puts " Centre ( $Cx, $Cy ) Apex ( $Ax, $Ay ) and Length ( $L ) "
#	puts "Pathgon is ( $P1x,$P1y, $Ax,$Ay, $P2x,$P2y )"

	set Path "($P1x,$P1y,$P2x,$P2y,$Bx,$By,$Ax,$Ay)"
	puts $Path
	return $Path
}
#
set GC(conn) [ mi_open Prod ]
mi_exec $GC(conn) "set schema GCMTest;"
mi_exec $GC(conn) "begin transaction;"
#
# Get the next Map_Id
#
set Qry "
SELECT MAX(Map_id) 
  FROM GCMTest.GCMTest;"
set Mid [ mi_select_first_row $GC(conn) $Qry ]
if { $Mid == "MI_ERROR" } {
	puts "ERROR: Failed on $Qry"
	mi_close $GC(conn)
	exit 0
} 
if { $Mid == "(null)" } {
	set Mid 0
}
incr Mid
#
for { set lat  -86 } { $lat < 86 } { incr lat 4 } {
	set long 0
	for { set long -180 } { $long < 180 } { incr long 5 } {
		set longT [ expr $long + 5 ]
		set latT [ expr $lat + 4 ]
		set Box "( $long, $lat,  $longT, $latT )"
		set Ur [ random 150 ]
		set U [ expr $Ur - 75 ]
                set Vr [ random 126 ]
		set V [ expr $Vr - 68  ]
                set Pr [ random 20 ]
		set P [ expr $Pr + 70 ]
		set Tr [ random 50 ]
		set T [ expr $Tr - 40 ]
		set Path [ lines $long.0 $lat.0 $longT.0 $latT.0 $U.0 $V.0 $P.0 150.0 126.0 100.0 ]
#
# Put it in the table
#
		set InsQry "
INSERT INTO GCMTest
( Map_id, BBox, VizUnit, T, U, V, P, Clouds )
VALUES
( $Mid, '$Box'::Box, '$Path'::Path, $T, $U, $V, $P, -1 );"

		set RetVal [ mi_exec $GC(conn) $InsQry ]
		if { $RetVal == "MI_ERROR" } {
			puts "ERROR: Failed on $InsQry"
			mi_exec $GC(conn) "end transaction;"
			mi_close $GC(conn)
			exit 0
		}
	}
}
mi_exec $GC(conn) "end transaction;"
