#
#
# set MD(connection) [ mi_open Prod ]
# mi_exec $MD(connection) "set schema GCMCheat;"
#
#
proc Min { a b } {
	if { $a > $b } {
		return $b
	} 
	return $a
}
#
proc Max { a b } {
	if { $a > $b } {
		return $a
	} 
	return $b
}
#
#
proc lines { x1 y1 x2 y2 U V P mU mV mP } {
#
# Set the Max and Min of the box (lower left is the origin)
#
	set X1 [ Min $x1 $x2 ]
	set X2 [ Max $x1 $x2 ]
	set Y1 [ Min $y1 $y2 ]
	set Y2 [ Max $y1 $y2 ]
#
# Find the Center
#
        set Cx [ expr ($X1 + $X2) / 2.0 ]
        set Cy [ expr ($Y1 + $Y2) / 2.0 ]
#
# Apex and Base
#
        set Ax [ expr $Cx + ($V / ( 1.0 * $mV)) ]
        set Ay [ expr $Cy + ($U / ( 1.0 * $mU)) ]
        set Bx [ expr $Cx - ($V / ( 1.0 * $mV)) ]
        set By [ expr $Cy - ($U / ( 1.0 * $mU)) ]
#
# Length of the line is
#
        set Hyp [ expr hypot($V, $U) ]
#
# Now the base
#
        set dY [ expr ((($V / 1.0) * ($P / ( 2.0 * $mP)))/($Hyp)) ]
        set dX [ expr ((($U / 1.0) * ($P / ( 2.0 * $mP)))/($Hyp)) ]
#
# Get the 1,2 points. (3 is the Apex)
#
        set Xof1 [ expr $Bx - $dX ]
        set Xof2 [ expr $Bx + $dX ]
        set Yof1 [ expr $By + $dY ]
        set Yof2 [ expr $By - $dY ]
#
# And return the result
#
	return "($Xof1,$Yof1, $Bx,$By, $Ax,$Ay, $Bx,$By, $Xof2,$Yof2)"
}
#
set GC(conn) [ mi_open Prod ]
mi_exec $GC(conn) "set schema GCMTest;"
mi_exec $GC(conn) "begin transaction;"
#
# Get the next Map_Id
#
set Qry "
SELECT MAX(Map_id) 
  FROM GCMTest.GCMTest;"
set Mid [ mi_select_first_row $GC(conn) $Qry ]
if { $Mid == "MI_ERROR" } {
	puts "ERROR: Failed on $Qry"
	mi_close $GC(conn)
	exit 0
} 
if { $Mid == "(null)" } {
	set Mid 0
}
incr Mid
#
for { set lat  -86 } { $lat < 86 } { incr lat 4 } {
	set long 0
	for { set long -180 } { $long < 180 } { incr long 5 } {
		set longT [ expr $long + 5 ]
		set latT [ expr $lat + 4 ]
		set Box "( $long, $lat,  $longT, $latT )"
		set Ur [ random 150 ]
		set U [ expr $Ur - 75 ]
                set Vr [ random 126 ]
		set V [ expr $Vr - 68  ]
                set Pr [ random 20 ]
		set P [ expr $Pr + 70 ]
		set Tr [ random 50 ]
		set T [ expr $Tr - 40 ]
		set Path [ lines $long.0 $lat.0 $longT.0 $latT.0 $U.0 $V.0 $P.0 150.0 126.0 100.0 ]
#
# Put it in the table
#
		set InsQry "
INSERT INTO GCMTest
( Map_id, BBox, VizUnit, T, U, V, P, Clouds )
VALUES
( $Mid, '$Box'::Box, '$Path'::Path, $T, $U, $V, $P, -1 );"

		set RetVal [ mi_exec $GC(conn) $InsQry ]
		if { $RetVal == "MI_ERROR" } {
			puts "ERROR: Failed on $InsQry"
			mi_exec $GC(conn) "end transaction;"
			mi_close $GC(conn)
			exit 0
		}
	}
}
mi_exec $GC(conn) "end transaction;"
