#
#  These are the basic functions used in each of the other
#  tcl files in this directory.
#
#
#  VMax - takes a value (x) and a measure of accuracy (a) and returns
#         the 'topside' value. This is used when mucking about with
#         floating point numbers. The point is to find a value which
#         is 'close enough' to be acceptable.
#
proc VMax { x a } {
 return [ expr $x + [ expr $a * [ expr abs ($x) ] ] ]
}
#
#  VMin - takes a value (x) and a measure of accuracy (a) and returns
#         the 'lowside' value. This is used (together with VMax) to
#         work out acceptable ranges for values.
#
proc VMin { x a } {
 return [ expr $x - [ expr $a * [ expr abs($x) ] ] ]
}
#
#  GetAttrMod - If the list (passed in as AttrModList) contains the
#               Attribute (passed in as Attr) then return the value
#               the attribute is to be modified to. Otherwise, return
#               just a ":-)" (It makes sense that this won't be asked
#               for, but almost anything else - a "", or a "-1", or
#               even "NULL", could be.
#
proc GetAttrMod { Attr AttrModList } {
        foreach i $AttrModList {
                set LAttr [ lindex $i 0 ]
                if { $Attr == $LAttr } {
                        return [ lindex $i 1 ]
                }
        }
        return ":-)"
}

