/*
 * get_result  - Get the result of the query and return it as a text string.
 * 
 *               The only context in which this is called is to do with the
 *               FileToLO() function. Need to get the LO name it returns for
 *               the dlobh URL format.
 */
#include "get_result.h"
char *
get_result ( conn )
MI_CONNECTION * conn;
{
  int count;
  int result;
  char *cmd;
  MI_ROW         *row;
  MI_ROW_DESC    *rowdesc;
  int            error;
  int            numcols;
  int            i;
  char           *colname;
  int            collen;
  char           *colval;

  char           *pRetVal;
  char           *pRetVal1;
  int            nRetLen = 0;

  pRetVal = (char *) NULL;
  pRetVal1 = (char *) NULL;

  while ((result = mi_get_result(conn)) != MI_NO_MORE_RESULTS)
  {
    switch(result)
    {
        case MI_ERROR:
            return (char *) NULL;
        case MI_DDL:
            break;
        case MI_DML:
            /* what kind of command was it? */
            cmd = mi_result_command_name(conn);

            /* get # rows affected by last command */
            if ((count = mi_result_row_count(conn)) == MI_ERROR)
            {
              return (char *) NULL;
            }
            break;
        case MI_ROWS:
    /* get the description of the row */
    rowdesc = mi_get_row_desc_without_row(conn);

    /* get the number of columns in the row */
    numcols = mi_column_count(rowdesc);

    /* for each row */
    while ((row = mi_next_row(conn, &error)) != NULL)
    {
        /* for each column */
        for (i = 0; i < numcols; i++)
        {
            switch(mi_value(row, i, &colval, &collen))
            {
              case MI_ERROR:
                return (char *) NULL;
              case MI_NULL_VALUE:
                colval = "NULL";
                collen = sizeof("NULL");
                break;
              case MI_NORMAL_VALUE:
                break;
              default:
                return (char *) NULL;
            }

        nRetLen+=collen;
        pRetVal1=mi_alloc(nRetLen);
	if (pRetVal != NULL)
	{
          sprintf(pRetVal1,"%s%s",pRetVal,colval);
	  mi_free(pRetVal);
        } else strcpy(pRetVal1,colval);
        pRetVal=pRetVal1;
        }
    }
            break;
        default:
          return (char *) NULL;
    }
  }


  return (pRetVal);
}


