#
proc Min { a b } {
	if { $a > $b } {
		return $b
	} 
	return $a
}
#
proc Max { a b } {
	if { $a > $b } {
		return $a
	} 
	return $b
}
#
#
proc lines { x1 y1 x2 y2 U V P mU mV mP } {
#
# Set up the Min/Max values to ensure that the 
# subsequent trig works OK.
#
	set MinX [ Min $x1 $x2 ]
	set MaxX [ Max $x1 $x2 ]
	set MinY [ Min $y1 $y2 ]
	set MaxY [ Max $y1 $y2 ]
#
#  Distances along each edge
#
	set Dx [ expr ( $MaxX - $MinX ) ]
	set Dy [ expr ( $MaxY - $MinY ) ]
#
# Center
#
	set Cx [ expr $MinX + ( $Dx / 2 ) ]
	set Cy [ expr $MinY + ( $Dy / 2 ) ]
#
# Apex
#
	set Ax [ expr $Cx + ( ( $V * $Dx ) / ( $mV * 2 ) ) ]
	set Ay [ expr $Cy + ( ( $U * $Dy ) / ( $mU * 2 ) ) ]
#
# Base
#
	set Bx [ expr $Cx - ( ( $V * $Dx ) / ( $mV * 2 ) ) ]
	set By [ expr $Cy - ( ( $U * $Dy ) / ( $mU * 2 ) ) ]
#
# Slope
#
#
# Now, the other two points.
#
	set Pp [ expr ( ($P / $mP) * ( hypot($Dx,$Dy) / 2 ) ) ]

	set P1x [ expr $Bx - sqrt(($Pp*$Pp)/(($Dy/$Dx)+1)*(($Dy/$Dx) + 1)) ]
        set P2x [ expr $Bx + sqrt(($Pp*$Pp)/(($Dy/$Dx)+1)*(($Dy/$Dx) + 1)) ]
	set P1y [ expr $By + sqrt(($Pp*$Pp)/(($Dx/$Dy)+1)*(($Dx/$Dy) + 1)) ]
	set P2y [ expr $By - sqrt(($Pp*$Pp)/(($Dx/$Dy)+1)*(($Dx/$Dy) + 1)) ]
#
# Length 
#
	puts " U is $U and mU is $mU "
	set dU [ expr ($U/$mU) ]
	puts " V is $V and mV is $mV "
	set dV [ expr ($V/$mV) ]
	puts " dU is $dU and dV is $dV "
	set L [ expr sqrt(((abs($U)/$mU )*(abs($U)/$mU)) + ((abs($V)/$mV)*(abs($V)/$mV))) ]
#
#  Test Print
#
	puts " Centre ( $Cx, $Cy ) Apex ( $Ax, $Ay ) and Length ( $L ) "

        puts "Polygon is ( $P1x,$P1y, $Ax,$Ay, $P2x,$P2y )"

}
