#
#
#   This script loads a set of initial values into the
#  database. It also serves as a test for the functions
#  defined in the other scripts.
#
# Connection
#
set MD(connection) [ mi_server_connect default ]
mi_login $MD(connection) Demo
mi_exec $MD(connection) "set schema BigSur;"
# set MD(connection) [ mi_server_connect production ]
# mi_login $MD(connection) BigSur
#
#  Load the Axes
#
set LongOID [ Add_Axis LONGITUDE Spatial Degrees 5.0 -180.0 0.005 72 ]
set LatOID [ Add_Axis LATITUDE Spatial Degrees 4.0 -86.0 0.005 44 ]
set SIGMOID [ Add_Axis SIGMA Spatial sigma_units 1.0 0 0.005 15 ]
set AxisTS01ID [ Add_Axis TIMESTEP Temporal Hours 6.0 0 0.005 1460 ] 
set AxisTS02ID [ Add_Axis TIMESTEP Temporal Hours 6.0 8760.0 0.005 1460 ]
set AxisTS03ID [ Add_Axis TIMESTEP Temporal Hours 6.0 17520.0 0.005 1460 ]
set AxisTS04ID [ Add_Axis TIMESTEP Temporal Hours 6.0 26280.0 0.005 1460 ]
set AxisTS05ID [ Add_Axis TIMESTEP Temporal Hours 6.0 35040.0 0.005 1460 ]
set AxisTS06ID [ Add_Axis TIMESTEP Temporal Hours 6.0 43800.0 0.005 1460 ]
set AxisTS07ID [ Add_Axis TIMESTEP Temporal Hours 6.0 52560.0 0.005 1460 ]
set AxisTS08ID [ Add_Axis TIMESTEP Temporal Hours 6.0 61320.0 0.005 1460 ]
set AxisTS09ID [ Add_Axis TIMESTEP Temporal Hours 6.0 70080.0 0.005 1460 ]
set AxisTS10OID [ Add_Axis TIMESTEP Temporal Hours 6.0 78840.0 0.005 1460 ]
set AxisTS11OID [ Add_Axis TIMESTEP Temporal Hours 6.0 87600.0 0.005 1460 ]
set AxisTS12OID [ Add_Axis TIMESTEP Temporal Hours 6.0 96360.0 0.005 1460 ]
#
#  There are 24 (twenty-four) grids formed by having 
#  LONGITUDE x LATITUDE x TIMESTEP
#
set GCMGrid3d01 [ Add_Grid GCMGrid3d.01 3 South-West-Early T [ list $LongOID $LatOID $AxisTS01ID ] ] 
set GCMGrid3d02 [ Add_Grid GCMGrid3d.02 3 South-West-Early T [ list $LongOID $LatOID $AxisTS02ID ] ] 
set GCMGrid3d03 [ Add_Grid GCMGrid3d.03 3 South-West-Early T [ list $LongOID $LatOID $AxisTS03ID ] ] 
set GCMGrid3d04 [ Add_Grid GCMGrid3d.04 3 South-West-Early T [ list $LongOID $LatOID $AxisTS04ID ] ] 
set GCMGrid3d05 [ Add_Grid GCMGrid3d.05 3 South-West-Early T [ list $LongOID $LatOID $AxisTS05ID ] ] 
set GCMGrid3d06 [ Add_Grid GCMGrid3d.06 3 South-West-Early T [ list $LongOID $LatOID $AxisTS06ID ] ] 
set GCMGrid3d07 [ Add_Grid GCMGrid3d.07 3 South-West-Early T [ list $LongOID $LatOID $AxisTS07ID ] ] 
set GCMGrid3d08 [ Add_Grid GCMGrid3d.08 3 South-West-Early T [ list $LongOID $LatOID $AxisTS08ID ] ] 
set GCMGrid3d09 [ Add_Grid GCMGrid3d.09 3 South-West-Early T [ list $LongOID $LatOID $AxisTS08ID ] ] 
set GCMGrid3d10 [ Add_Grid GCMGrid3d.10 3 South-West-Early T [ list $LongOID $LatOID $AxisTS10OID ] ] 
set GCMGrid3d11 [ Add_Grid GCMGrid3d.11 3 South-West-Early T [ list $LongOID $LatOID $AxisTS11OID ] ] 
set GCMGrid3d12 [ Add_Grid GCMGrid3d.12 3 South-West-Early T [ list $LongOID $LatOID $AxisTS12OID ] ] 
#
#  and by having LONGITUDE x LATITUDE x SIGMA x TIMESTEP
#
set GCMGrid4d01 [ Add_Grid GGCMGrid4d.01 4 South-West-Early-Ground T [ list $LongOID $LatOID $SIGMOID $AxisTS01ID ] ]
set GCMGrid4d02 [ Add_Grid GGCMGrid4d.02 4 South-West-Early-Ground T [ list $LongOID $LatOID $SIGMOID $AxisTS02ID ] ]
set GCMGrid4d03 [ Add_Grid GGCMGrid4d.03 4 South-West-Early-Ground T [ list $LongOID $LatOID $SIGMOID $AxisTS03ID ] ]
set GCMGrid4d04 [ Add_Grid GGCMGrid4d.04 4 South-West-Early-Ground T [ list $LongOID $LatOID $SIGMOID $AxisTS04ID ] ]
set GCMGrid4d05 [ Add_Grid GGCMGrid4d.05 4 South-West-Early-Ground T [ list $LongOID $LatOID $SIGMOID $AxisTS05ID ] ]
set GCMGrid4d06 [ Add_Grid GGCMGrid4d.06 4 South-West-Early-Ground T [ list $LongOID $LatOID $SIGMOID $AxisTS06ID ] ]
set GCMGrid4d07 [ Add_Grid GGCMGrid4d.07 4 South-West-Early-Ground T [ list $LongOID $LatOID $SIGMOID $AxisTS07ID ] ]
set GCMGrid4d08 [ Add_Grid GGCMGrid4d.08 4 South-West-Early-Ground T [ list $LongOID $LatOID $SIGMOID $AxisTS08ID ] ]
set GCMGrid4d09 [ Add_Grid GGCMGrid4d.09 4 South-West-Early-Ground T [ list $LongOID $LatOID $SIGMOID $AxisTS08ID ] ]
set GCMGrid4d10 [ Add_Grid GGCMGrid4d.10 4 South-West-Early-Ground T [ list $LongOID $LatOID $SIGMOID $AxisTS10OID ] ]
set GCMGrid4d11 [ Add_Grid GGCMGrid4d.11 4 South-West-Early-Ground T [ list $LongOID $LatOID $SIGMOID $AxisTS11OID ] ] 
set GCMGrid4d12 [ Add_Grid GGCMGrid4d.12 4 South-West-Early-Ground T [ list $LongOID $LatOID $SIGMOID $AxisTS12OID ] ] 
#
# Now add the variables; The first batch are the 3-d variables (Lacking altitude)
#
set TOPOG_OID [ Add_Variable_With_Abstract TOPOG float4 1 gm input "Topography" ]
set GW_OID [ Add_Variable_With_Abstract GW float4 1 Beta input "Ground wetness" ]
set GT_OID [ Add_Variable_With_Abstract GT float4 1 "Degrees Centigrade" prognostic "Ground temperature" ]
set SN_OID [ Add_Variable_With_Abstract SN float4 1 Centimeters prognostic "Snow depth" ]
set GC_OID [ Add_Variable_With_Abstract GC integer 1 "" input "Ground or vegetation type" ]
set IZ_OID [ Add_Variable_With_Abstract IZ float4 1 Centimeters diagnostic "Ice thickness" ]
set AL_OID [ Add_Variable_With_Abstract AL float4 1 "" input "Surface Albedo" ]
set SR_OID [ Add_Variable_With_Abstract SR float4 1 "" diagnostic "Surface roughness" ]
set PBL_U_OID [ Add_Variable_With_Abstract PBL_U float4 1 "Meters per Second" pseudo_prognostic "PBL zonal winds" ]
set PBL_V_OID [ Add_Variable_With_Abstract PBL_V float4 1 "Meters per Second" pseudo_prognostic "PBL meridional winds" ]
set PS_OID [ Add_Variable_With_Abstract PS float4 1 "Millibars" derived "Terain pressure" ]
set PSB_OID [ Add_Variable_With_Abstract PSB float4 1 "Millibars" prognostic "PBL depth" ]
set PBL_T_OID [ Add_Variable_With_Abstract PBL_T float4 1 "Degrees Centigrade" pseudo_prognostic "PBL temperature" ]
set PBL_RH_OID [ Add_Variable_With_Abstract PBL_RH float4 1 "Percentage" derived "PBL relative humidity"]
set PBL_SH_OID [ Add_Variable_With_Abstract PBL_SH float4 1 "Grams per Kilogram" pseudo_prognostic "PBL specific humidity" ]
set PBL_PHI_OID [ Add_Variable_With_Abstract PBL_PHI float4 1 "gm" derived "PBL geopotential hgt" ]
set SLP_OID [ Add_Variable_With_Abstract SLP float4 1 "Millibars" derived "Sea level pressure" ]
set PBL_H_OID [ Add_Variable_With_Abstract PBL_H float4 1 "" derived "PBL moist static energy" ]
set TS_OID [ Add_Variable_With_Abstract TS float4 1 "Degrees Centigrade" derived "Surface air temperature" ]
set PQ_OID [ Add_Variable_With_Abstract PQ float4 1 "Grams per Kilogram" derived "Precipitable water" ]
#
# These are the 4d Variables
#
set CLDS_OID [ Add_Variable_With_Abstract CLDS float4 1 "" diagnostic "Cloud Cover" ]
set U_WINDS_OID [ Add_Variable_With_Abstract U float4 1 "Meters per Second" prognostic "Zonal winds" ]
set V_WINDS_OID [ Add_Variable_With_Abstract V float4 1 "Meters per Second" prognostic "Meridional winds" ]
set TEMP_OID [ Add_Variable_With_Abstract T float4 1 "Degrees Kelvin" prognostic "Temperature" ]
set RH_OID [ Add_Variable_With_Abstract RH float4 1 "Percentage" derived "Relative Humidity" ]
set PHI_OID [ Add_Variable_With_Abstract PHI float4 1 "gm" derived "Geopotential height" ]
set SH_OID [ Add_Variable_With_Abstract SH float4 1 "Grams per Kilogram" prognostic "Specific Humidity" ]
set P_OID [ Add_Variable_With_Abstract P float4 1 "Millibars" prognostic "Model lvl pressure" ]
set O3_OID [ Add_Variable_With_Abstract O3 float4 1 "Grams per Kilogram" prognostic "Ozone" ]
#
#  Now construct the compounds
#
set TOPOG_CV_OID [ Add_Compound TOPOG 1 linearArray [ list [ list $TOPOG_OID ] ] ]
set GW_CV_OID [ Add_Compound GW 1 linearArray [ list [ list $GW_OID ] ] ]
set GT_CV_OID [ Add_Compound GT 1 linearArray [ list [ list $GT_OID ] ] ]
set SN_CV_OID [ Add_Compound SN 1 linearArray [ list [ list $SN_OID ] ] ]
set GC_CV_OID [ Add_Compound GC 1 linearArray [ list [ list $GC_OID ] ] ]
set IZ_CV_OID [ Add_Compound IZ 1 linearArray [ list [ list $IZ_OID ] ] ]
set AL_CV_OID [ Add_Compound AL 1 linearArray [ list [ list $AL_OID ] ] ]
set SR_CV_OID [ Add_Compound SR 1 linearArray [ list [ list $SR_OID ] ] ]
set PBL_U_CV_OID [ Add_Compound PBL_U 1 linearArray [ list [ list $PBL_U_OID ] ] ]
set PBL_V_CV_OID [ Add_Compound PBL_V 1 linearArray [ list [ list $PBL_V_OID ] ] ]
set PS_CV_OID [ Add_Compound PS 1 linearArray [ list [ list $PS_OID ] ] ]
set PSB_CV_OID [ Add_Compound PSB 1 linearArray [ list [ list $PSB_OID ] ] ]
set PBL_T_CV_OID [ Add_Compound PBL_T 1 linearArray [ list [ list $PBL_T_OID ] ] ]
set PBL_RH_CV_OID [ Add_Compound PBL_RH 1 linearArray [ list [ list $PBL_RH_OID ] ] ]
set PBL_SH_CV_OID [ Add_Compound PBL_SH 1 linearArray [ list [ list $PBL_SH_OID ] ] ]
set PBL_PHI_CV_OID [ Add_Compound PBL_PHI 1 linearArray [ list [ list $PBL_PHI_OID ] ] ]
set SLP_CV_OID [ Add_Compound SLP 1 linearArray [ list [ list $SLP_OID ] ] ]
set PBL_H_CV_OID [ Add_Compound PBL_H 1 linearArray [ list [ list $PBL_H_OID ] ] ]
set TS_CV_OID [ Add_Compound TS 1 linearArray [ list [ list $TS_OID ] ] ]
set PQ_CV_OID [ Add_Compound PQ 1 linearArray [ list [ list $PQ_OID ] ] ]
# 
# These are the 4d Variables 
#
set CLDS_CV_OID [ Add_Compound CLDS 1 linearArray [ list [ list $CLDS_OID ] ] ]
set U_WINDS_CV_OID [ Add_Compound U 1 linearArray [ list [ list $U_WINDS_OID ] ] ]
set V_WINDS_CV_OID [ Add_Compound V 1 linearArray [ list [ list $V_WINDS_OID ] ] ]
set TEMP_CV_OID [ Add_Compound T 1 linearArray [ list [ list $TEMP_OID ] ] ]
set RH_CV_OID [ Add_Compound RH 1 linearArray [ list [ list $RH_OID ] ] ]
set PHI_CV_OID [ Add_Compound PHI 1 linearArray [ list [ list $PHI_OID ] ] ]
set SH_CV_OID [ Add_Compound SH 1 linearArray [ list [ list $SH_OID ] ] ]
set P_CV_OID [ Add_Compound P 1 linearArray [ list [ list $P_OID ] ] ]
set O3_CV_OID [ Add_Compound O3 1 linearArray [ list [ list $O3_OID ] ] ]
#
#  
#  
# Now; The information about the people, from the bottom up.
#
#  Citations : The first one is for the UCLA GCM Model output . . .
#
set UCLAOID [ Add_Citation "Department of Atmospheric Sciences, UCLA" "" "UCLA Global Circulation Model data" \
"1" "model" "" "" "Los Angeles, CA" "University of California, UCLA" "" "" ]
#
set UCBOID [ Add_Citation "Electronics Research Lab, UC Berkeley" "" "Random data for test pruposes" \
"1" "binary" "" "" "Berkeley, CA" "University of California, Berkeley" "" ""]
#  
#
#  Contact: Forgive me, I used the power of finger! Note the line to seperate them
#
set SpahrOID [ Add_Contact "Mr Joseph Spahr" "Department of Atmospheric Sciences, UCLA" "Staff Researcher" \
2 "\[ UCLA, Department of Atmospheric Sciences \[MS 7343\], 405 Hilgard Ave \]" "Los Angeles" "CA" "90024-1565" \
"310-825-1555" "310-206-5219" "spahr@atmos.ucla.edu" "0900 - 1700 Pacific Time Zone" ]
#
set SklowerOID [ Add_Contact "Mr Keith Sklower" "Electronics Research Lab, UC Berkeley" "Staff Programmer" \
0 "\[\]" "" "" "" "510-642-9587" "510-642-5153" "sklower@cs.Berkeley.EDU" "" ]
#
set PGBOID [ Add_Contact "Mr Paul Brown" "Electronics Research Lab, UC Berkeley" "Staff Programmer" \
2 "\[ UC Berkeley, Soda Hall \[Mail Drop 1776\], Room 380 \]" "Berkeley" "CA" "94703" \
"510-642-7379" "310-642-5153" "pbrown@postgres.Berkeley.EDU" "" ]
#
#  Probably better to add more through MiBrowse . . .
#
#
# Right! Now the Lineage information!
#
set ProcOID [ Add_Process "Test Proc" 1 $PGBOID "" "" ]
set Parameter1OID [ Add_Parameter $ProcOID 1 "Test" "text" "Default" ]
set Parameter2OID [ Add_Parameter $ProcOID 2 "Test Again" "text" "Another" ]
#
# Now for the Real information;
#
set GCMOID [ Add_Process "UCLA GCM" 1 $SpahrOID "" "" ]
set GCM1OID [ Add_Parameter $GCMOID 1 "Initial Sea Surface Temperature" "file_name" "" ]
set GCM2OID [ Add_Parameter $GCMOID 2 "Initial Albedo" "file_name" "" ]
set GCM3OID [ Add_Parameter $GCMOID 3 "Initial Ground Wetness" "file_name" "" ]
set GCM4OID [ Add_Parameter $GCMOID 4 "Initial Topography" "file_name" "" ]
set GCM5OID [ Add_Parameter $GCMOID 5 "Initial Ground Type on Surface" "file_name" "" ]
set GCM6OID [ Add_Parameter $GCMOID 6 "Verticle Resolution" "integer" "15" ]
set GCM7OID [ Add_Parameter $GCMOID 7 "Horizontal Resolution" "integer" "5" ]
set GCM8OID [ Add_Parameter $GCMOID 8 "Cumulus Relaxation Method?" "boolean" "T" ]
set GCM9OID [ Add_Parameter $GCMOID 9 "Gravity Wave used?" "boolean" "T" ]
set GCM10OID [ Add_Parameter $GCMOID 10 "Pressure at Top of Model" "double precision" "0.0" ]
set GCM11OID [ Add_Parameter $GCMOID 11 "Pressure at Interface" "double precision" "0.0" ]
set GCM12OID [ Add_Parameter $GCMOID 12 "Timestep" "double precision" "6.0" ]
set GCM13OID [ Add_Parameter $GCMOID 13 "Dynamics(comp1) to Physics(comp3)" "integer" "1" ]
set GCM14OID [ Add_Parameter $GCMOID 14 "Dynamics(comp1) to Matsuno" "integer" "1" ]
set GCM15OID [ Add_Parameter $GCMOID 15 "dSigma spacing for Sigma Levels in the statosphere" "text" "" ]
#
# And another, general purpose ingestion proc
#
set IPOID [ Add_Process "Ingest File" 1 $PGBOID "" "" ]
set IPP1OID [ Add_Parameter $IPOID 1 "Source file Name" "file_name" "" ]
#
#  And a fourth, for the purpose of adding a top level entry in the 
# heirachy of Data_Sets (Identification_Informations)
#
set AddDataSetOID [ Add_Process "Add Data Set" 1 $PGBOID "" "" ]
set AddDataSet1OID [ Add_Parameter $AddDataSetOID 1 "Lengthy File Name" "file_name" "" ]
#
#  in consultation with Keith, I'm going to punt on the Planet Earth stuff. We can
# add that later.
#
 set ProcInstOID [ Add_ProcInstance $GCMOID $SpahrOID { "/tmp/ISST" "/tmp/IA" "/tmp/IGW" "/tmp/IT" "/tmp/IGTS" 
"15" "5" "T" "T" "0.0" "0.0" "6.0" "1" "1" "Thirteen" } "" ]
#
#  Now, I have the Citation, Contact, Grid/Axis, and Variable/Compound *and* a running Process.
#
#  Now, add some code information etc.
#
mi_exec $MD(connection) "
INSERT INTO Code
( Code_Type, Code_Value, Abstract )
VALUES
( 'USE', 'UNRESTRICTED', 'Unrestricted Use of this material is permitted.');"
#
mi_exec $MD(connection) "
INSERT INTO Code
( Code_Type, Code_Value, Abstract )
VALUES
( 'USE','PERMISSION_REQUEST','As a courtesy, it is requested that you check with the data source 
before using this material.');"
#
mi_exec $MD(connection) "
INSERT INTO Code
( Code_Type, Code_Value, Abstract )
VALUES
( 'ACCESS','PUBLIC','Public access to this data is permitted.');"
#
# . Security code
#
mi_exec $MD(connection) "
INSERT INTO Security_Code
( Code_Type, Code_Value, Abstract )
VALUES
( 'USE','READ_ONLY','Read only permission to data.');"
#
mi_exec $MD(connection) "
INSERT INTO Security_Code
( Code_Type, Code_Value, Abstract )
VALUES
( 'USE','READ_WRITE','Read and Write permission to data.');"
#
#
# Now add the Data_Set which is at the top level for the UCLA stuff, and a 
# tester. For this, I need to run an instance of the Process which adds top
# level data too.
#
set DSInstOID [ Add_ProcInstance $AddDataSetOID $PGBOID { "http://s2k-ftp.CS.Berkeley.EDU:8000/" } ""  ]
#
#
	set Qry "
INSERT INTO Identification_Information
( Data_Set_Id, Citation, Beginning, Ending, Status_Progress,
  Status_Update_Frequency, Spatial_Domain, Access_Constraints,
  Use_Constraints, Contact_Information, Data_Set_Credit,
  Security_Code, Native_Data_Set_Environment, Lineage_Process )
SELECT 'UCLA_GCM',
       ref(C),
       '1970-01-01 00:00:00'::timestamp,
       '2000-01-01 00:00:00'::timestamp,
       'TOP_LEVEL',
       '',
       '(-180,-90,180,90)'::Box::Poly,
       'PUBLIC',
       'PERMISSION_REQUEST',
       ref(Ct),
       'The Atmospheric Modelling Team at UCLA',
       'READ_ONLY',
       'Data generated from a GCM run on a CRAY SP-1',
       ref(LP)
  FROM Citation C, Contact_Information Ct, Lineage_Process LP
 WHERE Ct.oid  = '$SpahrOID'::oid
   AND C.oid   = '$UCLAOID'::oid
   AND LP.oid  = '$DSInstOID'::oid;"

	puts $Qry
	mi_exec $MD(connection) $Qry
#
#  Yeah! Now I have the top level dataset. I'll try this again with a test Data_Set
#
set TstInstOID [ Add_ProcInstance $AddDataSetOID $PGBOID { "http://epoch.CS.Berkeley.EDU:8000/personal/pbrown/" } ""  ]
##
##  DO NOT CUT AND PASTE THIS VERSION. ATTRIBUTES MISSING!!
##
        set Qry "
INSERT INTO Identification_Information
( Data_Set_Id, Citation, Beginning, Status_Progress,
  Status_Update_Frequency, Spatial_Domain, Access_Constraints,
  Use_Constraints, Contact_Information, Data_Set_Credit,
  Security_Code, Native_Data_Set_Environment, Lineage_Process )
SELECT 'Test Data Set',
       ref(C),
       '1970-01-01 00:00:00'::timestamp,
       'TOP_LEVEL',
       '',
       '(-180,-90,180,90)'::Box::Poly,
       'PUBLIC',
       'UNRESTRICTED',
       ref(Ct),
       'Thanks Mum and Dad',
       'READ_WRITE',
       'Data Grabbed from all kinds of places',
       ref(LP)
  FROM Citation C, Contact_Information Ct, Lineage_Process LP
 WHERE Ct.oid  = '$PGBOID'::oid
   AND C.oid   = '$UCBOID'::oid
   AND LP.oid  = '$TstInstOID'::oid;"

        puts $Qry
        mi_exec $MD(connection) $Qry

#
CloseDB
