#
# log.tcl - procedures to support the log window
#
# $Header: /usr/local/devel/montage/contrib/MiBrowse/lib/RCS/log.tcl,v 1.1 1994/12/22 02:36:27 pbrown Exp $
#

# ---------------------------------------------------------------------------
# LogClose - hide the log window
# ---------------------------------------------------------------------------
proc LogClose {} {update; wm withdraw .log}

# ---------------------------------------------------------------------------
# LogClear - clear the log window
# ---------------------------------------------------------------------------
proc LogClear {} {
    .log.text conf -state normal
    .log.text delete 0.0 end
    .log.text conf -state disabled
}

# ---------------------------------------------------------------------------
# Log -	add a message to the log
# ---------------------------------------------------------------------------
.log.text tag configure codefont -font -*-helvetica-*-o-*-*-*-120-*-*-*-*-*-*
set bg [lindex [.log.text conf -bg] 4]
.log.text tag configure codecolor -foreground red -background $bg
unset bg
proc Log {msg code} {
    if ![winfo exists .log] return
    .log.text conf -state normal
	set start [.log.text index end]
	.log.text insert end $code
	.log.text tag add codefont $start insert
	.log.text tag add codecolor $start insert
	set start [.log.text index end]
    .log.text insert end "\n$msg\n\n"
	.log.text tag remove codefont $start end
	.log.text tag remove codecolor $start end
    .log.text conf -state disabled
    .log.text yview -pickplace end
    update
}
proc LogSend {msg} {Log $msg sent:}
proc LogRec {msg} {Log $msg received:}

# ---------------------------------------------------------------------------
# LogOpen - opens the log window
# ---------------------------------------------------------------------------
proc LogOpen {} {
    if [winfo ismapped .log] return
    wm deiconify .log
    tkwait visibility .log.text
    focus .log.text
    .log.text yview -pickplace 0.0
}

# ---------------------------------------------------------------------------
# LogSave - prompts user for and then saves log to a file
# ---------------------------------------------------------------------------
proc LogSave { } {
    if {[set fd [Tku_FdOpenW -title "Save Log" -file msql.log]] == ""} {return 0}
    puts $fd [.log.text get 0.0 end]
    close $fd
}


proc LogCallbackMsg {conn name data} {
	set msg [keylget data errmsg]
	Tku_Error $msg
    	Log $msg [keylget data error_level]
}
