#include "MiTcl.h"

extern long strtol();

void
MiSetId(id, idp)
    char	   *id;
    void           *idp;
{
	(void) sprintf(id, "mip%lx", (long) idp);
}


void *
MiGetId(id)
    char           *id;
{
	long idp;
	idp = strtol(id+3, NULL, 16);
	return (void *) idp;
}


int
MiGetConn(interp, cid, conn)
    Tcl_Interp     *interp;
    char           *cid;
    MI_CONNECTION **conn;
{
    *conn = (MI_CONNECTION *) MiGetId(cid);
    return TCL_OK;
}


int
MiGetRdesc(interp, rdid, rdesc)
    Tcl_Interp     *interp;
    char           *rdid;
    MI_ROW_DESC   **rdesc;
{
    *rdesc = (MI_ROW_DESC *) MiGetId(rdid);
    return TCL_OK;
}


int
MiGetRow(interp, rid, row)
    Tcl_Interp     *interp;
    char           *rid;
    MI_ROW        **row;
{
    *row = (MI_ROW *) MiGetId(rid);
    return TCL_OK;
}


int
MiGetSS(interp, ssid, ss)
    Tcl_Interp     *interp;
    char           *ssid;
    MI_SAVE_SET   **ss;
{
    *ss = (MI_SAVE_SET *) MiGetId(ssid);
    return TCL_OK;
}


int
MiArgv1Conn(interp, argc, argv, conn)
    Tcl_Interp     *interp;
    int             argc;
    char          **argv;
    MI_CONNECTION **conn;
{
    if (argc != 2) {
	Tcl_AppendResult(interp, "wrong # args: should be \"",
			 argv[0], " connId\"", (char *) NULL);
	return TCL_ERROR;
    }
    if (MiGetConn(interp, argv[1], conn) != TCL_OK) {
	return TCL_ERROR;
    }
    return TCL_OK;
}


int
MiArgv2ColId(interp, argc, argv, rdesc, colid)
    Tcl_Interp     *interp;
    int             argc;
    char          **argv;
    MI_ROW_DESC   **rdesc;
    int            *colid;
{
    if (argc != 3) {
	Tcl_AppendResult(interp, "wrong # args:  should be \"",
			 argv[0], " rdescId colId \"", (char *) NULL);
	return TCL_ERROR;
    }
    if (MiGetRdesc(interp, argv[1], rdesc) != TCL_OK) {
	return TCL_ERROR;
    }
    if (Tcl_GetInt(interp, argv[2], colid) != TCL_OK) {
	return TCL_ERROR;
    }
    return TCL_OK;
}
