#include "MiTcl.h"

int 
Tmi_large_object_decrefcount(dummy, interp, argc, argv)
    ClientData      dummy;
    Tcl_Interp     *interp;
    int             argc;
    char          **argv;
{
    MI_CONNECTION  *conn;

    if (argc != 3) {
        Tcl_AppendResult(interp, "wrong # args: should be \"",
                         argv[0], " connId LO_Handle\"", (char *) NULL);
        return TCL_ERROR;
    }
    if (MiGetConn(interp, argv[1], &conn) != TCL_OK) {
        return TCL_ERROR;
    }

    if (mi_large_object_decrefcount(conn, argv[2]) == MI_ERROR) {
        Tcl_AppendResult(interp, "couldn't decrefcount for this LO\"",
                         argv[2], "\"", (char *) NULL);
        return TCL_ERROR;
    }
    return TCL_OK;
}

int
Tmi_large_object_increfcount(dummy, interp, argc, argv)
    ClientData      dummy;
    Tcl_Interp     *interp;
    int             argc;
    char          **argv;
{
    MI_CONNECTION  *conn;

    if (argc != 3) {
        Tcl_AppendResult(interp, "wrong # args: should be \"",
                         argv[0], " connId LO_Handle\"", (char *) NULL);
        return TCL_ERROR;
    }
    if (MiGetConn(interp, argv[1], &conn) != TCL_OK) {
        return TCL_ERROR;
    }

    if (mi_large_object_increfcount(conn, argv[2]) == MI_ERROR) {        
        Tcl_AppendResult(interp, "couldn't increfcount for this LO\"",
                         argv[2], "\"", (char *) NULL);
        return TCL_ERROR;
    }
    return TCL_OK;
}
